<?php

// ----------------------------
// RequestLogger with filters
// ----------------------------

$column_filter = array();

// ----------------------------
// Configuration
// ----------------------------


//Path - must have trailling slash (ie. C:\temp\ is okay, C:\temp is not okay)

$file_path = 'E:\UniServer\www\phprequestlogger\log\';

// Enter column filters here
// If no column filters are added, all columns will be used.

$column_filter['#serial-number'] = 1;
$column_filter['created'] = 1;
$column_filter['parameter-set-id no-error,,inst-value,0,0,0'] = 1;

// ----------------------------
// Configuration end
// ----------------------------



// ----------------------------
// Code
// ----------------------------

$filename = $_SERVER['Filename'];
if ($filename == '')
  $filename=date('YmdHis') . '.log';

$fullpath = $file_path . $filename;

$body = file_get_contents("minfil.txt");
$body = str_replace("\r", null, $body); // replace \r so that we can handle both unix/windows line endings.


$linearray = explode("\n",$body); // Split the input into lines.
$lines = count($linearray); // get the number of lines

if ($lines >= 2) // Make sure we have at least 2 lines. (1 column line and one value line)
{
  $columns = explode(";",$linearray[0]); // Get the columns

  $get_all_columns = 0;


  if (count($column_filter) == 0) // Get all columns if no filters have been given
    $get_all_columns = 1;

  // 1. Get the columns we will output
  $columns_to_output = array();
  foreach($columns as $column)
  {
    if ($get_all_columns || array_key_exists($column,$column_filter))
    {
      $columns_to_output[$column] = 1;
    }
  }

  $values = array(); // Create a new array 'values', this will contain an array of data arrays.

  for ($i = 1; $i < $lines; $i++)
  {
    $arr = explode(";",$linearray[$i]); // Get the data fields in all value lines
    $data = array(); // Create a new data array. Will contain column->value

    foreach($arr as $key => $value)
    {
      if (array_key_exists($columns[$key],$columns_to_output))
	$data[$columns[$key]] = $arr[$key]; // Bind column to value
    }

    $values[$i] = $data; // Add data array to our values array
  }


  // Output the data

  $fd = fopen($fullpath,"w+");

  // 2. Output columns
  $columns_out = implode(";",array_keys($columns_to_output));
  fwrite($fd,"$columns_out\r\n");

  // 3. Output values

  foreach($values as $data)
  {
    $value_out = implode(";",$data);
    fwrite($fd,"$value_out\r\n");
  }

  fclose($fd);

}



?>